-- MySQL dump 8.22
--
-- Host: localhost    Database: mailwatch
---------------------------------------------------------
-- Server version	3.23.54

--
-- Current Database: mailwatch
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ mailwatch;

USE mailwatch;

--
-- Table structure for table 'inq'
--

CREATE TABLE inq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM;

--
-- Table structure for table 'maillog'
--

CREATE TABLE maillog (
  timestamp timestamp(14) NOT NULL,
  id text,
  size bigint(20) default '0',
  from_address text,
  to_address text,
  subject text,
  clientip text,
  archive text,
  isspam tinyint(1) default '0',
  ishighspam tinyint(1) default '0',
  issaspam tinyint(1) default '0',
  isrblspam tinyint(1) default '0',
  spamwhitelisted tinyint(1) default '0',
  spamblacklisted tinyint(1) default '0',
  sascore decimal(7,2) default '0.00',
  spamreport text,
  virusinfected tinyint(1) default '0',
  nameinfected tinyint(1) default '0',
  otherinfected tinyint(1) default '0',
  report text,
  hostname text,
  date date default NULL,
  time time default NULL,
  headers text,
  KEY maillog_datetime_idx (date,time),
  KEY maillog_id_idx (id(20)),
  KEY maillog_from_idx (from_address(200)),
  KEY maillog_to_idx (to_address(200))
) TYPE=MyISAM;

--
-- Table structure for table 'outq'
--

CREATE TABLE outq (
  id text,
  cdate date default NULL,
  ctime time default NULL,
  from_address text,
  to_address text,
  subject text,
  message text,
  size text,
  priority text,
  attempts text,
  lastattempt text
) TYPE=MyISAM;

--
-- Table structure for table 'relay'
--

CREATE TABLE relay (
  id int(11) NOT NULL auto_increment,
  timestamp timestamp(14) NOT NULL,
  msg_id varchar(20) NOT NULL default '',
  relay text,
  status text,
  host text,
  PRIMARY KEY  (id),
  KEY msg_id (msg_id)
) TYPE=MyISAM;

--
-- Table structure for table 'sa_rules'
--

CREATE TABLE sa_rules (
  rule varchar(100) NOT NULL default '',
  rule_desc varchar(200) NOT NULL default '',
  PRIMARY KEY  (rule)
) TYPE=MyISAM;

--
-- Table structure for table 'user_filters'
--

CREATE TABLE user_filters (
  username varchar(20) NOT NULL default '',
  filter text,
  verify_key varchar(32) NOT NULL default '',
  active enum('N','Y') default 'N',
  KEY user_filters_username_idx (username)
) TYPE=MyISAM;

--
-- Table structure for table 'users'
--

CREATE TABLE users (
  username varchar(20) NOT NULL default '',
  password varchar(32) default NULL,
  fullname varchar(50) NOT NULL default '',
  type enum('A','D','U','R') NOT NULL default 'A',
  PRIMARY KEY  (username)
) TYPE=MyISAM;

