#!/usr/bin/php4 -q
<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require "/usr/share/mailwatch/functions.php";

$queue['inq'] = get_conf_var('IncomingQueueDir').'/';
$queue['outq'] = get_conf_var('OutgoingQueueDir').'/';

foreach($queue as $table_name=>$queuedir) {
 // Clear the output array
 unset($output);
 if($dh=opendir($queuedir)) {
  while(false !== ($file = readdir($dh))) {
   if(preg_match("/^qf/",$file)) {
    // Get rid of the 'qf' from the front of the filename to get the msgid
    $msgid = substr($file, 2);
    if(($fh = fopen($queuedir.$file, "r"))) {
     // Work out the total size (df+qf) of the mail
     $output[$msgid]['size'] = (@filesize($queuedir."df".$msgid) + filesize($queuedir."qf".$msgid));
     while(!@feof($fh)) {
      if(($line = @fgets($fh,1024))) {
       switch(true) {
        case preg_match('/^V(.+)$/',$line,$match):
         $output[$msgid]['version'] = $match[1];
         break;
        case preg_match('/^A(.+)$/',$line,$match):
         $output[$msgid]['auth'] = $match[1];
         break;
        case preg_match('/^C(.+)$/',$line,$match):
         $output[$msgid]['ctladdr'] = $match[1];
         break;
        case preg_match('/^Q(.+)$/',$line,$match):
         $output[$msgid]['orcpt'] = $match[1];
         break;
        case preg_match('/^r(.+)$/',$line,$match):
         $output[$msgid]['rcpt'] = $match[1];
         break;
        case preg_match('/^R.+<(.+)>$/',$line,$match):
         $output[$msgid]['rcpts'][] = $match[1];
         break;
        case preg_match('/^S<(.+)>$/',$line,$match):
         $output[$msgid]['sender'] = $match[1];
         break;
        case preg_match('/^T(.+)$/',$line,$match):
         $ctime = getdate($match[1]);
         $output[$msgid]['cdate'] = $ctime['year']."-".str_pad($ctime['mon'],2,"0",STR_PAD_LEFT)."-".str_pad($ctime['mday'],2,"0",STR_PAD_LEFT);
         $output[$msgid]['ctime'] = str_pad($ctime['hours'],2,"0",STR_PAD_LEFT).":".str_pad($ctime['minutes'],2,"0",STR_PAD_LEFT).":".str_pad($ctime['seconds'],2,"0",STR_PAD_LEFT);
         break;
        case preg_match('/^P(.+)$/',$line,$match):
         $output[$msgid]['priority'] = $match[1];
         break;
        case preg_match('/^M(.+)$/',$line,$match):
         $output[$msgid]['message'] = $match[1];
         break;
        case preg_match('/^F(.+)$/',$line,$match):
         $output[$msgid]['flags'] = $match[1];
         break;
        case preg_match('/^N(.+)$/',$line,$match):
         $output[$msgid]['attempts'] = $match[1];
         break;
        case preg_match('/^K(.+)$/',$line,$match):
         $output[$msgid]['lastattempttime'] = $match[1];
         break;
        case preg_match('/^Z(.+)$/',$line,$match):
         $output[$msgid]['envelopesender'] = $match[1];
         break;
        case preg_match('/Subject: (.+)$/',$line,$match):
         $output[$msgid]['subject'] = $match[1];
         break;
       }
      }
     }
    }
   }
  }
 }
 closedir($dh);
 // Drop everything from the table first
 dbquery("TRUNCATE TABLE ".$table_name);
 if(($output)) foreach($output as $msgid=>$msginfo) {
  // Insert each record
  $sql = ("
 INSERT INTO 
  ".$table_name."
  (id, 
   cdate, 
   ctime, 
   from_address, 
   to_address, 
   subject, 
   message,
   size, 
   priority, 
   attempts, 
   lastattempt) 
 VALUES (
  '".mysql_escape_string($msgid)."', 
  '".mysql_escape_string($msginfo['cdate'])."', 
  '".mysql_escape_string($msginfo['ctime'])."', 
  '".mysql_escape_string($msginfo['sender'])."', 
  '".mysql_escape_string(@join(",",$msginfo['rcpts']))."', 
  '".mysql_escape_string($msginfo['subject'])."', 
  '".mysql_escape_string($msginfo['message'])."',
  '".mysql_escape_string($msginfo['size'])."', 
  '".mysql_escape_string($msginfo['priority'])."', 
  '".mysql_escape_string($msginfo['attempts'])."', 
  '".mysql_escape_string($msginfo['lastattempttime'])."')
 ");
  dbquery($sql);
 }
}
?>
