<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

///////////////////////////////////////////////////////////////////////////////
// Settings - modify to suit your configuration
///////////////////////////////////////////////////////////////////////////////

// Debug messages
define(DEBUG, true);

include_once ('/etc/mailwatch/settings.php');
// Database settings
define(DB_TYPE, 'mysql');
define(DB_DSN, DB_TYPE.'://'.DB_USER.":".DB_PASS."@".DB_HOST."/".DB_NAME);

// LDAP settings
define(LDAP_HOST,'localhost');
define(LDAP_PORT,'389');
define(LDAP_DN,'o=fsmg');
define(LDAP_SITE,'default');

// Paths
define(MS_CONFIG_PATH, '/etc/MailScanner/');
define(MS_LIB_PATH, '/usr/share/MailScanner/MailScanner/');
define(CACHE_DIR, './images/cache/'); // JpGraph cache
define(TTF_DIR,'./jpgraph/fonts/'); // JpGraph fonts
define(SA_RULES_DIR, '/usr/share/spamassassin/');
define(SA_PREFS, MS_CONFIG_PATH.'spam.assassin.prefs.conf');

// Default number of results on Recent Messages and Message Listing Report
define(MAX_RESULTS, 50);
// Default refresh rate in seconds for the Recent Messages screen
define(STATUS_REFRESH, 30);

// Set the following to a value greater than zero to limit the length of the 
// From, To and Subject columns in the 'Recent Messages' screen. 
define(FROMTO_MAXLEN, 0);
define(SUBJECT_MAXLEN, 0);

// Quarantine settings
define(QUARANTINE_FROM_ADDR, 'postmaster');
define(QUARANTINE_SUBJECT, 'Message released from quarantine');
define(QUARANTINE_MSG_BODY, 'Please find the original message that was quarantined attached to this mail.

Regards,
Postmaster');
// Set this to A = Admin, U = Users, or O = off (old behaviour).
// Setting this to U is very dangerous!
define(QUARANTINE_RELEASE_DANGEROUS, 'A');

// Set this to true to hide things that won't work correctly if you have
// a distributed set of MailScanners logging to a single database.
define(DISTRIBUTED_SETUP, false);

// Display the inbound/outbound mail queue lengths
// Note: this only works with Sendmail, and you need to run mailq.php from cron
define(MAILQ, true);

// Are we running on MSEE?
define(MSEE, false);

// Force SSL connections only?
define(SSL_ONLY, true);

// Strip HTML from messages in the quarantine when viewed?
// This is probably a good idea...
define(STRIP_HTML, true);
// List of allowed tags - set as blank to strip everything
define(ALLOWED_TAGS, '<a><br><b><body><div><font><h1><h2><h3><h4><head><html><i><li><ol><p><small><span><strong><table><title><tr><td><th><u><ul>');

// Override VIRUS_REGEX??
// define(VIRUS_REGEX, '');
?>
