<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

class Filter { 
 var $item; 
 var $operators = array(
  '='			=>		"is equal to",
  '<>'			=>		"is not equal to",
  '>'			=>		"is greater than",
  '>='			=>		"is greater than or equal to",
  '<'			=>		"is less than",
  '<='			=>		"is less than or equal to",
  'LIKE'		=>		"contains",
  'NOT LIKE'		=>		"does not contain",
  'REGEXP'		=>		"matches the regular expression",
  'NOT REGEXP'		=>		"does not match the regular expression"
 );
 var $columns = array(
  'date_from'		=>		"Date From (YYYY-MM-DD)",
  'date_to'		=>		"Date To (YYYY-MM-DD)",
  'headers'		=>		"Headers",
  'id' 			=> 		"Message ID",
  'size'		=>		"Size (bytes)",
  'from_address'	=>		"From",
  'to_address'		=>		"To",
  'subject'		=>		"Subject",
  'clientip'		=>		"Received from (IP Address)",
  'isspam'		=>		"is Spam (>0 = TRUE)",
  'issaspam'		=>		"is Spam according to SpamAssassin (>0 = TRUE)",
  'isrblspam'		=>		"is Listed in one or more RBL's (>0 = TRUE)",
  'spamwhitelisted'	=>		"is Whitelisted (>0 = TRUE)",
  'spamblacklisted'	=>		"is Blacklisted (>0 = TRUE)",
  'sascore'		=>		"SpamAssassin Score",
  'spamreport'		=>		"Spam Report",
  'virusinfected'	=>		"contained a Virus (>0 = TRUE)",
  'nameinfected'	=>		"contained an Unacceptable Attachment (>0 = TRUE)",
  'otherinfected'	=>		"contained other infections (>0 = TRUE)",
  'report'		=>		"Virus Report",
  'hostname'		=>		"MailScanner Hostname"
 );
 var $reports = array();

 function Add($column, $operator, $value) {
  $this->item[$column] = array($operator, $value);
 }

 function Remove($column) {
  unset($this->item[$column]);
 }

 function Display() {
  echo "<TABLE ALIGN=\"CENTER\" WIDTH=500 BORDER=0 CLASS=\"BOXTABLE\">\n";
  echo " <TR><TH COLSPAN=2>Active Filters</TH></TR>\n";
  if(count($this->item)>0) {
   foreach($this->item as $key=>$val) {
    echo "<TR><TD>".
         $this->TranslateColumn($key)." ".$this->TranslateOperator($val[0]).
         " '".$val[1]."'</TD><TD ALIGN=\"RIGHT\"><A HREF=\"".$_SERVER["PHP_SELF"]."?action=remove&column=$key\">Remove</A></TD></TR>\n"; 
   }
  } else {
   echo "<TR><TD COLSPAN=2>None</TD></TR>\n";
  }
  echo " <TR><TH COLSPAN=2>Add Filter</TH></TR>\n";
  echo " <TR><TD COLSPAN=2>".$this->DisplayForm()."</TD></TR>\n";
  echo " <TR><TH COLSPAN=2>Statistics (Filtered)</TH></TR>\n";
  $query = "
SELECT
 DATE_FORMAT(MIN(date),'%d/%m/%Y') AS oldest,
 DATE_FORMAT(MAX(date),'%d/%m/%Y') AS newest,
 COUNT(*) AS messages
FROM
 maillog
WHERE
 1=1
".$this->CreateSQL();
  $sth = dbquery($query);
  while($row = mysql_fetch_object($sth)) {
   echo " <TR><TD>Oldest record:</TD><TD ALIGN=\"RIGHT\">$row->oldest</TD></TR>\n";
   echo " <TR><TD>Newest record:</TD><TD ALIGN=\"RIGHT\">$row->newest</TD></TR>\n";
   echo " <TR><TD>Message count:</TD><TD ALIGN=\"RIGHT\">$row->messages</TD></TR>\n";
  }
  echo "<TR><TH COLSPAN=2>Reports</TH></TR>\n";
  echo "<TR><TD COLSPAN=2><UL>\n";
  foreach($this->reports as $description=>$url) {
   echo "<LI><A HREF=\"$url\">$description</A>\n";
  } 
  echo "</TD></TR>\n";
  echo "</TABLE>\n";
 }

 function CreateSQL() {
  $sql .= "AND ".$GLOBALS['global_filter']."\n";
  if(count($this->item)>0) {
   foreach($this->item as $key=>$val) {
    if($key == "date_from" || $key == "date_to") { 
     $key = "DATE"; 
    }
    if(is_numeric($val[1])) { 
     $sql .= "AND\n $key $val[0] $val[1]\n";
    } else {
     $sql .= "AND\n $key $val[0] '$val[1]'\n";
    }
   }
   return $sql;
  } else {
   return "AND ".$GLOBALS['global_filter']."\n";
  }
 }

 function TranslateColumn($column) {
  return($this->columns[$column]); 
 }

 function TranslateOperator($operator) {
  return($this->operators[$operator]);
 }

 function DisplayForm() {
  // Form
  $return .= "<FORM ACTION=\"$_SERVER[PHP_SELF]\">\n";

  // Table
  $return .= "<TABLE WIDTH=100%>\n";

  // Columns
  $return .= "<TR><TD>\n";
  $return .= "<SELECT NAME=\"column\">\n";
  foreach($this->columns as $key=>$val) {
   if (!isset($this->item[$key])) {
    $return .= " <OPTION VALUE=\"$key\">$val</OPTION>\n";
   }
  }
  $return .= "</SELECT>\n";
  $return .= "</TD></TR>\n";
  
  // Operators
  $return .= "<TR><TD>\n";
  $return .= "<SELECT NAME=\"operator\">\n";
  foreach($this->operators as $key=>$val) {
   $return .= " <OPTION VALUE=\"$key\">$val</OPTION>\n";
  }
  $return .= "</SELECT><BR/>\n";  
  $return .= "</TD></TR>\n";

  // Input
  $return .= "<TR><TD>\n";
  $return .= "<INPUT TYPE=\"TEXT\" SIZE=50 NAME=\"value\">\n";
  $return .= "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"add\">\n";
  $return .= "<INPUT TYPE=\"SUBMIT\" VALUE=\"Add\">\n";
  $return .= "</TR></TD>\n";
  $return .= "</FORM>\n";
 
  return $return;
 }

 function AddReport($url, $description) {
  $this->reports[$description] =  $url;
 }
}
