<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Read in MailWatch configuration file
if(!(@include_once('conf.php'))==true) {
 die("Cannot read conf.php - please create it by copying conf.php.example and modifying the parameters to suit.\n");
}

if (SSL_ONLY && (!empty($_SERVER['PHP_SELF']) && !preg_match('/^\/usr\//', $_SERVER['PHP_SELF']))) {
 if (!$_SERVER['HTTPS'] == 'on') {
  header("Location: https://".$_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF']);
  exit;
 }
}

// Set PHP path to use local PEAR modules only
ini_set('include_path','.:./pear');

/*
 For reporting of Virus names and statistics a regular expression matching
 the output of your virus scanner is required.  As Virus names vary across
 the vendors and are therefore impossible to match - you can only define one 
 scanner as your primary scanner - this should be the scanner you wish to 
 report against.  It defaults to the first scanner found in MailScanner.conf.

 Please submit any new regular expressions to the MailWatch mailing-list or
 to me - smf@f2s.com.

 If you are running MailWatch in DISTRIBUTED_MODE or you wish to override the
 selection of the regular expression - you will need to add on of the following
 statements to conf.php and set the regular expression manually.
*/
// define(VIRUS_REGEX, '<<your regexp here>>');
// define(VIRUS_REGEX, '/(\S+) was infected by (\S+)/');

if(!defined(VIRUS_REGEX) || !DISTRIBUTED_SETUP) {
 switch($scanner=get_primary_scanner()) {
  case 'sophos':
   define(VIRUS_REGEX, '/(>>>) Virus \'(\S+)\' found/');
   break;
  case 'sophossavi':
   define(VIRUS_REGEX, '/(\S+) was infected by (\S+)/');
   break;
  case 'clamav':
   define(VIRUS_REGEX, '/(.+) contains (\S+)/');
   break;
  case 'clamavmodule':
   define(VIRUS_REGEX, '/(.+) was infected: (\S+)/');
   break;
  case 'f-prot':
   define(VIRUS_REGEX, '/(.+) Infection: (\S+)/');
   break;
  case 'mcafee':
   define(VIRUS_REGEX, '/(.+) Found the (\S+) virus !!!/');
   break;
  case 'f-secure':
   define(VIRUS_REGEX, '/(.+) Infected: (\S+)/');
   break;
  default:
   die("<B>Error:</B><BR>\n&nbsp;Unable to select a regular expression for your primary virus scanner ($scanner) - please see the examples in functions.php to create one.\n");
   break;
 }
} else {
 // Have to set manually as running in DISTRIBUTED_MODE
 die("<B>Error:</B><BR>\n&nbsp;You are running MailWatch in distributed mode therefore MailWatch cannot read your MailScanner configuration files to acertain your primary virus scanner - please edit functions.php and manually set the VIRUS_REGEX constant for your primary scanner.\n");
}

///////////////////////////////////////////////////////////////////////////////
// Functions
///////////////////////////////////////////////////////////////////////////////

// Reset globals
$GLOBALS['global_filter'] = '1';

function html_start($title,$refresh=0,$cacheable=true) {
 page_creation_timer();
 if (!$cacheable) {
  // Cache control (as per PHP website)
  header("Expires: Sat, 10 May 2003 00:00:00 GMT");
  header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
 }
?>
<HTML>
<HEAD>
<? if(MSEE): ?>
<TITLE>MailWatch for Fortress SMG - <?=$title?></TITLE>
 <LINK REL="StyleSheet" TYPE="text/css" HREF="style_msee.css">
<? else: ?>
<TITLE>MailWatch for MailScanner - <?=$title?></TITLE>
 <LINK REL="StyleSheet" TYPE="text/css" HREF="style.css">
<? endif; ?>
<?
 if ($refresh > 0) {
  echo "<META HTTP-EQUIV=\"refresh\" CONTENT=\"$refresh\">";
 }
?>
</HEAD>
<BODY>
<TABLE BORDER=0 CELLPADDING=5 WIDTH=100%>
 <TR>
  <TD>
   <TABLE BORDER=0 WIDTH=100% HEIGHT=140 CELLPADDING=0 CELLSPACING=0>
    <TR>
    <? if(MSEE): ?>
     <TD HEIGHT=48 VALIGN="TOP" ALIGN="LEFT" BACKGROUND="images/fsl_smg_bg.gif"><IMG SRC="images/fsl_smg.gif"></TD>
    <? else: ?>
     <TD ALIGN="LEFT"><IMG SRC="images/mailscannerlogo.gif"></TD>
    <? endif; ?>
    </TR>
    <TR>
     <FORM ACTION="detail.php">
     <TD VALIGN="BOTTOM" ALIGN="LEFT" CLASS="jump">
      Jump to message: <INPUT TYPE="TEXT" NAME="id" VALUE="<?=$_GET['id']?>">
     </TD>
     </FORM>
    </TR>
   </TABLE>
  </TD>
<?
echo "  <TD ALIGN=\"RIGHT\" VALIGN=\"TOP\" WIDTH=20%>\n";
// Mail Queues display
if(MAILQ) {
 $inq = mysql_result(dbquery("SELECT COUNT(*) FROM inq WHERE ".$GLOBALS['global_filter']),0);
 $outq = mysql_result(dbquery("SELECT COUNT(*) FROM outq WHERE ".$GLOBALS['global_filter']),0);
 echo "   <TABLE BORDER=0 CLASS=\"MAIL\" WIDTH=200>\n";
 echo "    <THEAD><TH ALIGN=\"CENTER\" COLSPAN=2>Mail Queue</TH></THEAD>\n";
 echo "    <TR><TD><A HREF=\"mailq.php?queue=inq\">Inbound Queue:</A></TD><TD>".$inq."</TD>\n";
 echo "    <TR><TD><A HREF=\"mailq.php?queue=outq\">Outbound Queue:</A></TD><TD>".$outq."</TD>\n";
 echo "   </TABLE>\n";
 echo "   <BR>\n";
}
// Load average
if(file_exists("/proc/loadavg") && !DISTRIBUTED_SETUP) {
 $loadavg = file("/proc/loadavg");
 $loadavg = explode(" ", $loadavg[0]);
 $la_1m = $loadavg[0];
 $la_5m = $loadavg[1];
 $la_15m = $loadavg[2];
 echo "   <TABLE BORDER=0 CLASS=\"MAIL\" WIDTH=200>\n";
 echo "    <THEAD><TH ALIGN=\"CENTER\" COLSPAN=3>Load Average</TH></THEAD>\n";
 echo "    <THEAD>\n";
 echo "     <TH>1 min</TH>\n";
 echo "     <TH>5 min</TH>\n";
 echo "     <TH>15 min</TH>\n";
 echo "    </THEAD>\n";
 echo "    <TR>\n";
 echo "     <TD ALIGN=\"CENTER\">".$la_1m."</TD>\n";
 echo "     <TD ALIGN=\"CENTER\">".$la_5m."</TD>\n";
 echo "     <TD ALIGN=\"CENTER\">".$la_15m."</TD>\n";
 echo "    </TR>\n";
 echo "   </TABLE>\n";
}
echo "  </TD>\n";
?>
  <TD WIDTH=20% ALIGN="RIGHT">
<?
$sql = "
 SELECT
  COUNT(*) AS processed,
  SUM(CASE WHEN virusinfected>0 THEN 1 ELSE 0 END) AS viruses,
  ROUND((SUM(CASE WHEN virusinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS viruspercent,
  SUM(CASE WHEN nameinfected>0 THEN 1 ELSE 0 END) AS blockedfiles,
  ROUND((SUM(CASE WHEN nameinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS blockedfilespercent,
  SUM(CASE WHEN otherinfected>0 THEN 1 ELSE 0 END) AS otherinfected,
  ROUND((SUM(CASE WHEN otherinfected>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS otherinfectedpercent,
  SUM(CASE WHEN isspam>0 THEN 1 ELSE 0 END) AS spam,
  ROUND((SUM(CASE WHEN isspam>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS spampercent,
  SUM(CASE WHEN ishighspam>0 THEN 1 ELSE 0 END) AS highspam,
  ROUND((SUM(CASE WHEN ishighspam>0 THEN 1 ELSE 0 END)/COUNT(*))*100,1) AS highspampercent,
  SUM(size) AS size 
 FROM
  maillog
 WHERE
  ".$GLOBALS['global_filter']."
 AND
  date = CURRENT_DATE()
";

$sth = dbquery($sql);
while($row = mysql_fetch_object($sth)) {
 echo "<TABLE BORDER=0 CLASS=\"mail\" WIDTH=200>\n";
 echo " <THEAD><TH ALIGN=\"CENTER\" COLSPAN=3>Today's Totals</TH></THEAD>\n";
 echo " <TR><TD>Processed:</TD><TD ALIGN=\"RIGHT\">".$row->processed."</TD><TD ALIGN=\"RIGHT\">".format_mail_size($row->size)."</TD></TR>\n";
 echo " <TR><TD>Spam:</TD><TD ALIGN=\"RIGHT\">$row->spam</TD><TD ALIGN=\"RIGHT\">$row->spampercent%</TD></TR>\n";
 echo " <TR><TD NOWRAP>High Scoring Spam:</TD><TD ALIGN=\"RIGHT\">$row->highspam</TD><TD ALIGN=\"RIGHT\">$row->highspampercent%</TD></TR>\n";
 echo " <TR><TD>Viruses:</TD><TD ALIGN=\"RIGHT\">$row->viruses</TD><TD ALIGN=\"RIGHT\">$row->viruspercent%</TR>\n";
 echo " <TR><TD>Top Virus:</TD><TD COLSPAN=2 ALIGN=\"RIGHT\" NOWRAP>".return_todays_top_virus()."</TD></TR>\n";
 echo " <TR><TD>Blocked files:</TD><TD ALIGN=\"RIGHT\">$row->blockedfiles</TD><TD ALIGN=\"RIGHT\">$row->blockedfilespercent%</TD></TR>\n";
 echo " <TR><TD>Others:</TD><TD ALIGN=\"RIGHT\">$row->otherinfected</TD><TD ALIGN=\"RIGHT\">$row->otherinfectedpercent%</TD></TR>\n";
 echo "</TABLE>\n";

 // Navigation links - put them into an array to allow them to be switched
 // on or off as necessary and to allow for the table widths to be calculated.
 $nav['status.php'] 	= "Recent Messages";
 if(!DISTRIBUTED_SETUP) { $nav['quarantine.php'] = "Quarantine"; }
 $nav['reports.php'] 	= "Reports";
 $nav['other.php'] 	= "Other";
 $nav['docs.php'] 	= "Documentation";
 $nav['logout.php']	= "Logout";
 $table_width = round(100/count($nav));
}
?>
  </TD>
 </TR>
 <TR>
  <TD COLSPAN=3>
   <TABLE CLASS="navigation" WIDTH=100%>
    <TR ALIGN=CENTER>
<?
foreach($nav as $url=>$desc) {
 echo "     <TD WIDTH=\"$table_width%\"><A HREF=\"$url\">$desc</A></TD>\n";
}
?>
    </TR>
   </TABLE>
  </TD>
 </TR>
 <TR>
  <TD COLSPAN=3>
<?
 return $refresh;
}

function report_start($title) {
 // Cache control (as per PHP website)
 header("Expires: Sat, 10 May 2003 00:00:00 GMT");
 header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
 header("Cache-Control: no-store, no-cache, must-revalidate");
 header("Cache-Control: post-check=0, pre-check=0", false);
?>
<HTML>
<HEAD>
<TITLE>MailWatch for MailScanner Report: <?=$title?></TITLE>
<LINK REL="StyleSheet" TYPE="text/css" HREF="style.css">
</HEAD>
<BODY>
<?
}


function html_end($footer="") {
?>
  <TD>
 </TR>
</TABLE>
<?=$footer?>
<BR>
<FONT SIZE=-2><I><CENTER><?=page_creation_timer();?></CENTER></I></FONT>
</BODY>
</HTML>
<?
}

function dbconn() {
 $link = mysql_pconnect(DB_HOST,DB_USER,DB_PASS)
        or die ("Could not connect to database: ".mysql_error());
 mysql_select_db(DB_NAME) or die("Could not select db: ".mysql_error());
 return $link;
}

function dbquery($sql) {
 dbconn();
 if(DEBUG && headers_sent() && preg_match('/^select/i',$sql)) {
  echo "<!--\n\n";
  $dbg_sql = "EXPLAIN ".$sql;
  echo "SQL:\n\n$sql\n\n";
  $result = mysql_query($dbg_sql) or die("Error executing query: ".mysql_error());
  $fields = mysql_num_fields($result);
  $rows = mysql_num_rows($result);
  while($row=mysql_fetch_row($result)) {
   for($f=0; $f<$fields; $f++) {
    echo mysql_field_name($result,$f).": ".$row[$f]."\n";
   }
  }
  echo "\n-->\n\n";
 }
 $result = mysql_query($sql) or die("<B>Error executing query: </B><BR/><BR/>".mysql_error()."<BR/><BR/><B>SQL:</B><BR/><PRE>$sql</PRE>");
 return $result;
}

function authenticate() {
 if(!MSEE) {
  $user = $_SERVER['PHP_AUTH_USER'];
  $pass = $_SERVER['PHP_AUTH_PW'];
  $sql = "SELECT fullname, type FROM users WHERE username='$user' AND password=md5('$pass')";
  $sth = dbquery($sql);
  $result = mysql_fetch_row($sth);
  if (isset($user) && isset($pass) && mysql_num_rows($sth) > 0) {
   $GLOBALS['full_name'] = $result[0];
   $GLOBALS['user_type'] = $result[1];
   $sql = "SELECT filter FROM user_filters WHERE active='Y' and username='$user'";
   $sth = dbquery($sql);
   if(mysql_num_rows($sth)>0) {
    while($row=mysql_fetch_array($sth)) {
     $filters[] = $row[0];
    }
    $GLOBALS['global_filter'] = address_filter_sql($filters,$GLOBALS['user_type']); 
   } else {
    $GLOBALS['global_filter'] = "1=1";
   }
   return;
  } else {
   header('WWW-Authenticate: Basic realm="MailWatch for MailScanner"');
   header('HTTP/1.0 401 Unauthorized');
   html_start("Not authenticated");
   echo "<TABLE CLASS=\"BOXTABLE\" WIDTH=100%><TR><TD><H1><FONT COLOR=\"RED\">Authentication Required!</FONT></H1>Your username and/or password are incorrect.<br><br><a href=\"index.php\">Login</a></TD></TR>\n";
   html_end();
   exit;
  }
 } else {
  // MSEE uses session-base authentication
  session_start();
  // Read in MSEE's authentication mechanism
  ini_set('include_path',ini_get('include_path').':/opt/Fortress/web');
  require 'include/auth.php';
  if(isset($_SESSION['AUTH']) && $_SESSION['AUTH'] == 1 && $_SESSION['user_level'] == 'admin') {
   // User has been successfully authenticated
   return;
  } else {
   // Redirect to MSEE login-screen
   header("Location: /");
  }
 }
}

function logout() {
 if(!MSEE) {
   header('WWW-Authenticate: Basic realm="MailWatch for MailScanner"');
   header('HTTP/1.0 401 Unauthorized');
   html_start("Re-Authenticate");
   echo "<TABLE CLASS=\"BOXTABLE\" WIDTH=100%><TR><TD><H1><FONT COLOR=\"RED\">Authentication Required!</FONT></H1>Your username and/or password are incorrect.<br><br><a href=\"index.php\">Login</a></TD></TR>\n";
   html_end();
   exit;
 }
}

function format_spam_report($spamreport) {
 /* Run regex against the MailScanner spamreport
 picking out the (score=xx, required x, RULES...) */
 if(preg_match('/SpamAssassin \((.+?)\)/i',$spamreport,$sa_rules)) {
  // Get rid of the first match from the array
  array_shift($sa_rules);
  // Split the array
  $sa_rules = explode(", ",$sa_rules[0]);
  // Check to make sure a check was actually run
  if ($sa_rules[0] == "Message larger than max testing size" || $sa_rules[0] == "timed out") {
   return $sa_rules[0];
  }
  // Get rid of the 'score=' and 'required' lines
  array_shift($sa_rules);
  array_shift($sa_rules);
  //
  $output_array = array();
  while(list($key,$val)=each($sa_rules)) {
   array_push($output_array,get_sa_rule_desc($val));
  }
  // Return the result as an html formatted string 
  if(count($output_array)>0) {
   return "<TABLE BORDER=0 CLASS=\"sa_rules_report\" CELLPADDING=1 CELLSPACING=2 WIDTH=100%>"."<THEAD><TH>Score</TH><TH>Matching Rule</TH><TH>Description</TH></THEAD>".implode("\n",$output_array)."</TABLE>\n"; 
  } else {
   return $spamreport;
  }
 } else {
  // Regular expression did not match, return unmodified report instead
  return $spamreport;
 }
}

function get_sa_rule_desc($rule) {
 // Check if SA scoring is enabled
 if(preg_match('/^(.+) (.+)$/',$rule,$regs)) {
  $rule = $regs[1];
  $rule_score = $regs[2];
 } else {
  $rule_score = "";
 }
 $result = dbquery("SELECT rule, rule_desc FROM sa_rules WHERE rule='$rule'");
 $row = mysql_fetch_object($result,1);
 if ($row->rule && $row->rule_desc) {
  return("<TR><TD ALIGN=\"LEFT\">$rule_score</TD><TD WIDTH=\"200\">$row->rule</TD><TD>$row->rule_desc</TD></TR>");
 } else {
  return "<TR><TD>$rule_score<TD>$rule</TD><TD>&nbsp;</TD></TR>";
 }
}

function return_sa_rule_desc($rule) {
 $result = dbquery("SELECT rule, rule_desc FROM sa_rules WHERE rule='$rule'");
 $row = mysql_fetch_object($result,1);
 return $row->rule_desc;
}
 

function return_todays_top_virus() {
 $sql = "
SELECT
 report
FROM
 maillog
WHERE
 report IS NOT NULL
AND
 report != \"\"
AND
 date = CURRENT_DATE()
";
 $result = dbquery($sql);
 $virus_array = array();
 while($row=mysql_fetch_object($result)) {
  if(preg_match(VIRUS_REGEX,$row->report,$virus_reports)) {
   $virus = $virus_reports[2];
   $virus_array[$virus]++;
  }
 }
 arsort($virus_array);
 reset($virus_array);
 // Get the topmost entry from the array
 if ((list($key, $val) = each($virus_array)) != "") {
  // Check and make sure there first placed isn't tied!
  $saved_key = $key;
  $saved_val = $val;
  list($key, $val) = each($virus_array);
  if ($val != $saved_val) {
   return $saved_key;
  } else {
   // Tied first place - return none
   return "None";
  }
 } else {
  return "None";
 }
}

function format_mail_size($size_in_bytes, $decimal_places=1) {
 // Setup common measurements
 $kb = 1024;		// Kilobyte
 $mb = 1024*$kb;	// Megabyte
 $gb = 1024*$mb;	// Gigabyte
 $tb = 1024*$gb;	// Terabyte
 if($size_in_bytes < $kb) {
  return $size_in_bytes."b";
 } else if ($size_in_bytes < $mb) {
  return round($size_in_bytes/$kb,$decimal_places)."Kb";
 } else if ($size_in_bytes < $gb) {
  return round($size_in_bytes/$mb,$decimal_places)."Mb";
 } else if ($size_in_bytes < $tb) {
  return round($size_in_bytes/$gb,$decimal_places)."Gb";
 } else {
  return round($size_in_bytes/$tb,$decimal_places)."Tb";
 }
}

function format_report_volume(&$data_in, &$info_out) {
 // Measures
 $kb = 1024;
 $mb = 1024*$kb;
 $gb = 1024*$mb;
 $tb = 1024*$gb;

 // Copy the data to a temporary variable
 $temp = $data_in;

 // Work out the average size of values in the array
 $count = count($temp);
 $sum = array_sum($temp);
 $average = $sum/$count;

 // Work out the largest value in the array
 arsort($temp);
 $largest = array_pop($temp);

 // Calculate the correct display size for the average value
 if($average < $kb) {
  $info_out['formula'] = 1;
  $info_out['shortdesc'] = "b";
  $info_out['longdesc'] = "Bytes";
 } else if ($average < $mb) {
  $info_out['formula'] = $kb;
  $info_out['shortdesc'] = "Kb";
  $info_out['longdesc'] = "Kilobytes";
 } else if ($average < $gb) {
  $info_out['formula'] = $mb;
  $info_out['shortdesc'] = "Mb";
  $info_out['longdesc'] = "Megabytes";
 } else if ($average < $tb) {
  $info_out['formula'] = $gb;
  $info_out['shortdesc'] = "Gb";
  $info_out['longdesc'] = "Gigabytes";
 } else {
  $info_out['formula'] = $tb;
  $info_out['shortdesc'] = "Tb";
  $info_out['longdesc'] = "Terabytes";
 }

 // Modify the original data accordingly
 for($i=0; $i<sizeof($data_in); $i++) {
  $data_in[$i] = $data_in[$i]/$info_out['formula'];
 }
}

function trim_output($input, $maxlen) {
 if (strlen($input) >= $maxlen) {
  $output = substr($input, 0, $maxlen)."...";
  return $output;
 } else {
  return $input;
 }
}


function get_conf_var($name) {
 // Translate input if using LDAP on MSEE
 if(MSEE) {
  $name = translate_etoi($name);
  return ldap_get_conf_var($name);
 } else {
  $msconfig = MS_CONFIG_PATH."/MailScanner.conf";
  $fh = fopen($msconfig,'r') 
   or die("Cannot open MailScanner configuration file");
  while(!feof($fh)) {
   $line = rtrim(fgets($fh, filesize($msconfig)));
   if(preg_match('/^([^#].+) = ([^#].+)/',$line,$regs)) {
    $regs[1] = ereg_replace(' *', '', $regs[1]); 
    if((strtolower($regs[1])) == (strtolower($name))) {
     fclose($fh) or die($php_errormsg);
     return $regs[2];
    }
   }
  }
  fclose($fh) or die($php_errormsg);
  die("Cannot find configuration value: $name in $msconfig\n");
 }
}

function get_primary_scanner() {
 // Might be more than one scanner defined - pick the first as the primary
 $scanners = explode(" ",get_conf_var('VirusScanners'));
 return $scanners[0];
}

function translateQuarantineDate($date, $format='dmy') {
 $y = substr($date,0,4);
 $m = substr($date,4,2);
 $d = substr($date,6,2);

 switch($format) {
  case 'dmy': 
   return "$d/$m/$y";
   break;
  case 'sql':
   return "$y-$m-$d";
   break;
 }
}

function subtract_get_vars($preserve) {
 if(is_array($_GET)) {
  foreach($_GET as $k=>$v) {
   if(strtolower($k) !== strtolower($preserve)) {
    $output[] = "$k=$v";
   }
  }
  if(is_array($output)) {
   $output = join('&',$output);
   return '&'.$output;
  } else {
   return false;
  }
 } else {
  return false;
 }
}


function subtract_multi_get_vars($preserve) {
 if(is_array($_GET)) {
  foreach($_GET as $k=>$v) {
   if(!in_array($k,$preserve)) {
    $output[] = "$k=$v";
   }
  }
  if(is_array($output)) {
   $output = join('&',$output);
   return '&'.$output;
  } else {
   return false;
  }
 } else {
  return false;
 }
}

function db_colorised_table($sql, $table_heading=false, $pager=false, $order=false) {
 require_once 'Mail/mimeDecode.php';

 // Ordering
 $orderby = $_GET['orderby'];
 switch(strtoupper($_GET['orderdir'])) {
  case 'A':
   $orderdir='ASC';
   break;
  case 'D':
   $orderdir='DESC';
   break;
 }
 if(!empty($orderby)) {
  if(($p = stristr($sql,'ORDER BY')) !== false) {
   // We already have an existing ORDER BY clause
   $p = "ORDER BY\n  ".$orderby.' '.$orderdir.','.substr($p,(strlen('ORDER BY')+2));
   $p = substr($sql,0,strpos($sql,'ORDER BY')).$p;
   $sql = $p;
  } else {
   // No existing ORDER BY - disable feature
   $order=false;
  }
 }

 if($pager) {
  require_once 'DB/Pager.php';
  if(isset($_GET['offset'])) {
   $from = intval($_GET['offset']);
  } else {
   $from = 0;
  }
  
  // Remove any ORDER BY clauses as this will slow the count considerably
  if($pos=strpos($sql,"ORDER BY")) {
   $sqlcount = substr($sql,0,$pos);
  }

  // Count the number of rows that would be returned by the query
  $sqlcount = "SELECT COUNT(*) ".strstr($sqlcount,"FROM");
  $rows = mysql_result(dbquery($sqlcount),0);
  
  // Build the pager data
  $data = DB_Pager::getData($from, MAX_RESULTS, $rows, 20); 

  if($rows>0) {
   if($data['numpages']>1) {
?>
 <table border=0 class="mail">
  <thead>
   <th colspan=5>Displaying page <?=$data['current']?> of <?=$data['numpages']?> - Records <?=$data['from']?> to <?=$data['to']?> of <?=$data['numrows']?></th>
  </thead>
  <tr>
   <!-- First page -->
   <td>
    <?
    if(isset($data['prev'])) {
     printf("<a href=\"%s?offset=%d%s\"><<</a>\n",$_SERVER['PHP_SELF'],0,subtract_get_vars('offset'));
    } else {
     printf("<<\n");
    }
    ?>
   </td>
   <!-- Previous page -->
   <td>
    <?
    if(isset($data['prev'])) {
     printf("<a href=\"%s?offset=%d%s\"><</a>\n",$_SERVER['PHP_SELF'],$data['prev'],subtract_get_vars('offset'));
    } else {
     printf("<\n");
    }
    ?>
   </td>
   <!-- Direct links to page (Google-style) -->
   <td align="center">
   <?
    // Links to each page
    foreach($data['pages'] as $page=>$start) {
     if($data['current'] == $page) {
      printf("%s&nbsp;\n",$page); 
     } else {
      printf("<a href=\"%s?offset=%d%s\">%s</a>&nbsp;\n",$_SERVER['PHP_SELF'],$start,subtract_get_vars('offset'),$page);
     }
    }
   ?>
   </td>
   <!-- Next Page -->
   <td align="right">
    <?
    if(isset($data['next'])) {
     printf("<a href=\"%s?offset=%d%s\">></a>\n",$_SERVER['PHP_SELF'],$data['next'],subtract_get_vars('offset'));
    } else {
     printf(">\n");
    }
    ?>
   </td>
   <!-- Last Page -->
   <td align="right">
    <?
    if(isset($data['next'])) {
     printf("<a href=\"%s?offset=%d%s\">>></a>\n",$_SERVER['PHP_SELF'],($data['numpages']-1)*$data['limit'],subtract_get_vars('offset'));
    } else {
     printf(">>\n");
    }
    ?>
  </tr>
 </table>
 </td>
</tr>
<tr>
 <td colspan=3>
<?
   }
   // Re-run the original query and limit the rows
   $sql .= " LIMIT $from,".MAX_RESULTS;
   $sth = dbquery($sql);
   $rows = mysql_num_rows($sth);
   $fields = mysql_num_fields($sth);
  }
 } else {
   $sth = dbquery($sql);
   $rows = mysql_num_rows($sth);
   $fields = mysql_num_fields($sth);
 }

 if($rows>0) {
  echo "<table border=0 width=\"100%\" class=\"mail\">\n";
  // Work out which columns to display
  for($f=0; $f<$fields; $f++) {
   $display[$f] = true;
   $orderable[$f] = true;
   $align[$f] = false;
   switch($fieldname[$f]=mysql_field_name($sth,$f)) {
    case 'host':
     $fieldname[$f] = "Host";
     if(DISTRIBUTED_SETUP) {
      $display[$f] = true;
     } else {
      $display[$f] = false;
     }
     break;
    case 'timestamp':
     $fieldname[$f] = "Date/Time";
     break;
    case 'datetime':
     $fieldname[$f] = "Date/Time";
     break;
    case 'id':
     $fieldname[$f] = "ID";
     $orderable[$f] = false;
     break;
    case 'id2':
     $fieldname[$f] = "#";
     $orderable[$f] = false;
     break;
    case 'size':
     $fieldname[$f] = "Size";
     $align[$f] = "RIGHT";
     break;
    case 'from_address':
     $fieldname[$f] = "From";
     break;
    case 'to_address':
     $fieldname[$f] = "To";
     break;
    case 'subject':
     $fieldname[$f] = "Subject";
     break;
    case 'clientip':
     $display[$f] = true;
     break;
    case 'archive':
     $display[$f] = false;
     break;
    case 'isspam':
     $display[$f] = false;
     break;
    case 'ishighspam':
     $display[$f] = false;
     break;
    case 'issaspam':
     $display[$f] = false;
     break;
    case 'isrblspam':
     $display[$f] = false;
     break;
    case 'spamwhitelisted':
     $display[$f] = false;
     break;
    case 'spamblacklisted':
     $display[$f] = false;
     break;
    case 'spamreport':
     $display[$f] = false;
     break;
    case 'virusinfected':
     $display[$f] = false;
     break;
    case 'nameinfected':
     $display[$f] = false;
     break;
    case 'otherinfected':
     $display[$f] = false;
     break;
    case 'report':
     $display[$f] = false;
     break;
    case 'hostname':
     if(DISTRIBUTED_SETUP) {
      $display[$f] = true;
     } else {
      $display[$f] = false;
     }
     break;
    case 'date':
     $fieldname[$f] = 'Date';
     break;
    case 'time':
     $fieldname[$f] = 'Time';
     break;
    case 'headers':
     $display[$f] = false;
     break;
    case 'sascore':
     $fieldname[$f] = "SA Score";
     $align[$f] = "RIGHT";
     break;
    case 'status':
     $fieldname[$f] = "Status";
     $orderable[$f] = false;
     break;
    case 'message':
     $fieldname[$f] = "Message";
     break;
    case 'attempts':
     $fieldname[$f] = "Tries";
     $align[$f] = "RIGHT";
     break;
    case 'lastattempt':
     $fieldname[$f] = "Last";
     $align[$f] = "RIGHT";
     break;
   }
  }
  // Table heading
  if(isset($table_heading) && $table_heading != "") {
   // Work out how many columns are going to be displayed
   $column_headings=0;
   for($f=0; $f<$fields; $f++) {
    if($display[$f]) {
     $column_headings++;
    }
   }
   echo " <thead>\n";
   echo "  <th colspan=$column_headings>$table_heading</th>\n";
   echo " </thead>\n";
  }
  // Column headings
  echo " <thead>\n";
  for($f=0; $f<$fields; $f++) {
   if($display[$f]) {
    if($order && $orderable[$f]) {
     echo "  <th>\n";
     echo "  $fieldname[$f] (<a href=\"?orderby=".mysql_field_name($sth,$f)."&orderdir=a".subtract_multi_get_vars(array('orderby','orderdir'))."\">A</a>/<a href=\"?orderby=".mysql_field_name($sth,$f)."&orderdir=d".subtract_multi_get_vars(array('orderby','orderdir'))."\">D</a>)\n";
     echo "  </th>\n";
    } else {
     echo "  <th>".$fieldname[$f]."</th>\n";
    }
   }
  }
  echo " </thead>\n";
  // Rows
  for($r=0; $r<$rows; $r++) {
   $row = mysql_fetch_row($sth);
   // Work out field colourings and mofidy the incoming data as necessary
   // and populate the generate an overall 'status' for the mail.
   $status_array = array();
   $infected = false;
   $highspam = false;
   $spam = false;
   $whitelisted = false;
   $blacklisted = false;
   for($f=0; $f<$fields; $f++) { 
    $field = mysql_field_name($sth, $f);
    switch($field) {
     case 'id':
      // Create a link to detail.php
      $row[$f] = "<a href=\"detail.php?id=$row[$f]\">$row[$f]</a>";
      break;
     case 'id2':
      // Create a link to detail.php as [<link>]
      $row[$f] = "[<a href=\"detail.php?id=$row[$f]\">&nbsp;&nbsp;</a>]";
      break;
     case 'from_address':
      $row[$f] = htmlentities($row[$f]);
      if(FROMTO_MAXLEN>0) {
       $row[$f] = trim_output($row[$f], FROMTO_MAXLEN);
      }
     case 'to_address':
      $row[$f] = htmlentities($row[$f]);
      if(FROMTO_MAXLEN>0) {
       // Trim each address to specified size
       $to_temp = explode(",",$row[$f]);
       for($t=0;$t<count($to_temp);$t++) {
        $to_temp[$t] = trim_output($to_temp[$t], FROMTO_MAXLEN);
       }
       // Return the data
       $row[$f] = implode(",",$to_temp);
      }
      // Put each address on a new line
      $row[$f] = str_replace(",","<br />",$row[$f]);
      break;
     case 'subject':
      $row[$f] = decode_header($row[$f]);
      $row[$f] = htmlentities($row[$f]);
      if(SUBJECT_MAXLEN>0) {
       $row[$f] = trim_output($row[$f], SUBJECT_MAXLEN);
      }
      break;
     case 'isspam':
      if($row[$f] == 'Y' || $row[$f] == 1) {
       $spam = true;
       array_push($status_array,'Spam');
      }
      break;
     case 'ishighspam':
      if($row[$f] == 'Y' || $row[$f] == 1) { 
       $highspam = true; 
      }
      break;
     case 'virusinfected':
      if($row[$f] == 'Y' || $row[$f] == 1) {
       $infected = true;
       array_push($status_array,'Virus');
      }
      break;
     case 'report':
      // IMPORTANT NOTE: for this to work correctly the 'report' field MUST
      // appear after the 'virusinfected' field within the SQL statement.
      if(preg_match(VIRUS_REGEX,$row[$f],$virus)) {
       foreach($status_array as $k=>$v) {
        if($v = preg_replace('/Virus/',"Virus ($virus[2])",$v)) {
         $status_array[$k] = $v;
        }
       }
      } 
      break;
     case 'nameinfected':
      if($row[$f] == 'Y' || $row[$f] == 1) { 
       $infected = true; 
       array_push($status_array,'Bad Content');
      }
      break;
     case 'otherinfected':
      if($row[$f] == 'Y' || $row[$f] == 1) {
       $infected = true;
       array_push($status_array,'Other');
      }
      break;
     case 'size':
      $row[$f] = format_mail_size($row[$f]);
      break;
     case 'spamwhitelisted':
      if($row[$f] == 'Y' || $row[$f] == 1) { 
       $whitelisted = true;
       array_push($status_array,'W/L'); 
      }
      break;
     case 'spamblacklisted':
      if($row[$f] == 'Y' || $row[$f] == 1) {
       $blacklisted = true;
       array_push($status_array,'B/L');
      }
      break;
     case 'clienthost':
      $hostname = gethostbyaddr($row[$f]);
      if($hostname == $row[$f]) {
       $row[$f] = "(Hostname lookup failed)";
      } else {
       $row[$f] = $hostname;
      }
      break;
     case 'status':
      // NOTE: this should always be the last row for it to be displayed correctly
      // Work out status
      if(count($status_array) == 0) {
       $status = "Clean";
      } else {
       $status = join("<br />",$status_array);
      }
      $row[$f] = $status;    
      break;
    }
   }
   // Colorise the row
   switch(true) {
    case $infected:
     echo "<tr class=\"infected\">\n";
     break;
    case $whitelisted:
     echo "<tr class=\"whitelisted\">\n";
     break;
    case $blacklisted:
     echo "<tr class=\"blacklisted\">\n";
     break;
    case $highspam:
     echo "<tr class=\"highspam\">\n";
     break;
    case $spam:
     echo "<tr class=\"spam\">\n";
     break;
    default:
     echo "<tr>\n";
     break;
   }
   // Display the rows
   for($f=0; $f<$fields; $f++) {
    if($display[$f]) {
     if($align[$f]) {
      echo " <td align=\"".$align[$f]."\">".$row[$f]."</td>\n";
     } else {
      echo " <td>".$row[$f]."</td>\n";
     }
    }
   }
   echo " </tr>\n";
  } 
  echo "</table>\n";
 } else {
  echo "No rows retrieved.\n";
 }
}

function dbtable($sql) {
 $sth = dbquery($sql);
 $rows = mysql_num_rows($sth);
 $fields = mysql_num_fields($sth);
 
 if($rows>0) {
  echo "<TABLE BORDER=0 WIDTH=\"100%\" CLASS=\"mail\">\n";
  // Column headings
  echo " <THEAD>\n";
  for($f=0;$f<$fields;$f++) {
   echo "  <TH>".mysql_field_name($sth,$f)."</TH>\n";
  } 
  echo " </THEAD>\n";
  // Rows
  while($row=mysql_fetch_row($sth)) {
   echo " <TR>\n";
   for($f=0;$f<$fields;$f++) {
    echo "  <TD>".$row[$f]."</TD>\n";
   }
   echo " </TR>\n";
  }
  echo "</TABLE>\n";
 } else {
  echo "No rows retrieved!\n";
 }
}

function db_vertical_table($sql) {
 $sth = dbquery($sql);
 $rows = mysql_num_rows($sth);
 $fields = mysql_num_fields($sth);
 
 if($rows>0) {
  echo "<TABLE BORDER=1 CLASS=\"mail\">\n";
  while($row=mysql_fetch_row($sth)) {
   for($f=0; $f<$fields; $f++) {
    echo " <TR>\n";
    echo "  <TD>".mysql_field_name($sth, $f)."</TD>\n";
    echo "  <TD>".$row[$f]."</TD>\n";
    echo " </TR>\n";
   }
  }
  echo "</TABLE>\n";
 } else {
  echo "No rows retrieved\n";
 }
}

function array_table($array, $keyed=false) {
 return false;
}

function get_microtime() {
 $mtime = explode(" ",microtime());
 $mtime = $mtime[1] + $mtime[0];
 return $mtime;
}

function page_creation_timer() {
 if(!isset($GLOBALS[pc_start_time])) {
  $GLOBALS[pc_start_time] = get_microtime();
 } else {
  $pc_end_time = get_microtime();
  $pc_total_time = $pc_end_time - $GLOBALS[pc_start_time];
  printf("Page generated in %f seconds\n", $pc_total_time);
 }
}

function debug($text) {
 if(DEBUG && headers_sent()) {
  echo "<!-- DEBUG: $text -->\n";
 }
}

function return_24_hour_array() {
 for($h=0; $h<24; $h++) {
  if(strlen($h) < 2) {
   $h = "0".$h;
  } 
  $array[$h] = 0;
 }
 return $array;
}

function return_60_minute_array() {
 for($m=0; $m<60; $m++) {
  if(strlen($m) < 2) {
   $m = "0".$m;
  }
  $array[$m] = 0;
 }
 return $array;
}

function return_time_array() {
 for($h=0; $h<24; $h++) {
  if(strlen($h) < 2) {
   $h = "0".$h;
  }
  for($m=0; $m<60; $m++) {
   if(strlen($m) < 2) {
    $m = "0".$m;
   }
   $array[$h][$m] = 0;
  }
 }
 return $array;
}

function count_files_in_dir($dir) {
 if(!$drh = @opendir($dir)) {
  return false;
 } else {
  while(false!==($file=readdir($drh))) {
   if($file !== "." && $file !== "..") {
    $array[] = $file;
   }
  }
 }
 return count($array);
}


function get_mail_relays($message_headers) {
 $headers = explode("\\n",$message_headers);
 foreach($headers as $header) {
  if(preg_match('/\[(\d+\.\d+\.\d+\.\d+)\]/',$header,$regs)) {
   $relays[] = $regs[1];
   //$clientip[$ip]++;
  }
 }
 return $relays;
}

function address_filter_sql($addresses, $type) {
 switch($type) {
  case 'A': // Administrator - show everything
   return "1=1";
   break;
  case 'U': // User - show only specific addresses
   // From User
   $from_count=0;
   foreach($addresses as $address) {
    $from[$from_count] = "from_address='$address'";
    $from_count++;
   } 
   // To User
   $to_count=0;
   foreach($addresses as $address) {
    $to[$to_count] = "to_address='$address'";
    $to_count++;
  }
   // Join together to form a suitable SQL WHERE clause
   $from = join(' OR ',$from);
   $to = join(' OR ',$to);
   return "(($from) OR ($to))";
   break;
  case 'D':  // Domain administrator
   // From Domain
   $from_count=0;
   foreach($addresses as $domain) {
    $from[$from_count] = "from_address LIKE '%@$domain'";
    $from_count++;
   }
   // To Domain
   $to_count=0;
   foreach($addresses as $domain) {
    $to[$to_count] = "to_address LIKE '%@$domain'";
    $to_count++;
   }
   // Join together to form a suitable SQL WHERE clause
   $from = join(' OR ',$from);
   $to = join(' OR ',$to);
   return "(($from) OR ($to))";
   break;
  case 'R': // Regexp
   // From
   $from_count=0;
   foreach($addresses as $regexp) {
    $from[$from_count] = "from_address REGEXP '$regexp'";
    $from_count++;
   }
   // To
   $to_count=0;
   foreach($addresses as $regexp) {
    $to[$to_count] = "to_address REGEXP '$regexp'";
    $to_count++;
   }
   // Join
   $from = join(' OR ',$from);
   $to = join(' OR ',$to);
   return "(($from) OR ($to))";
   break;
 }
}

function ldap_get_conf_var($entry) {
 // Translate MailScanner.conf vars to internal
 $entry = translate_etoi($entry);

 $lh = @ldap_connect(LDAP_HOST, LDAP_PORT) 
  or die("Error: could not connect to LDAP directory on: ".LDAP_HOST."\n");

 @ldap_bind($lh) 
  or die("Error: unable to bind to LDAP directory\n");

 # As per MailScanner Config.pm
 $filter = "(objectClass=mailscannerconfmain)";
 $filter = "(&$filter(mailScannerConfBranch=main))";
 
 $sh = ldap_search($lh, LDAP_DN, $filter, array($entry));

 $info = ldap_get_entries($lh, $sh);
 debug(debug_print_r($info));
 if($info['count']>0 && $info[0]['count'] <> 0) {
  if($info[0]['count'] == 0) {
   // Return single value
   return $info[0][$info[0][0]][0];
  } else {
   // Multi-value option, build array and return as space delimited
   for($n=0; $n<$info[0][$info[0][0]]['count']; $n++) {
    $return[] = $info[0][$info[0][0]][$n];
   }
   return join(" ",$return);
  }
 } else {
  // No results
  die("Error: cannot find configuration value '$entry' in LDAP directory.\n");
 }
}

function translate_etoi($name) {
 $name = strtolower($name);
 $file = MS_LIB_PATH.'ConfigDefs.pl';
 $fh = fopen($file,'r')
  or die("Cannot open MailScanner ConfigDefs file: $file\n");
 while(!feof($fh)) {
  $line = rtrim(fgets($fh, filesize($file)));
  if(preg_match('/^([^#].+)\s=\s([^#].+)/i',$line,$regs)) {
   // Lowercase all values
   $regs[1] = strtolower($regs[1]);
   $regs[2] = strtolower($regs[2]);
   $etoi[rtrim($regs[2])] = rtrim($regs[1]);
  }
 }
 fclose($fh) or die($php_errormsg);
 if(isset($etoi["$name"])) {
  return $etoi["$name"];
 } else {
  return $name;
 }
}

function decode_header($input) {
 // Remove white space between encoded-words
 $input = preg_replace('/(=\?[^?]+\?(q|b)\?[^?]*\?=)(\s)+=\?/i', '\1=?', $input);
 // For each encoded-word...
 while (preg_match('/(=\?([^?]+)\?(q|b)\?([^?]*)\?=)/i', $input, $matches)) {
  $encoded  = $matches[1];
  $charset  = $matches[2];
  $encoding = $matches[3];
  $text     = $matches[4];
  switch (strtolower($encoding)) {
   case 'b':
    $text = base64_decode($text);
    break;
   case 'q':
    $text = str_replace('_', ' ', $text);
    preg_match_all('/=([a-f0-9]{2})/i', $text, $matches);
    foreach($matches[1] as $value)
     $text = str_replace('='.$value, chr(hexdec($value)), $text);
    break;
   }
  $input = str_replace($encoded, $text, $input);
 }
 return $input;
}

function debug_print_r($input) {
 ob_start();
 print_r($input);
 $return = ob_get_contents();
 ob_end_clean();
 return $return;
}
?>
