<?
require("./functions.php");
authenticate();
html_start("Quarantine Viewer");

$quarantinedir = get_conf_var("QuarantineDir");

if(!isset($_GET['dir']) && !isset($_GET["msgdir"])) {
 // Display top level quarantine directories
 $d = @opendir($quarantinedir) or die("Cannot open directory: $quarantinedir");
 while(false !== ($f = readdir($d))) {
  if ($f !== "." && $f !== "..") {
   $items[] = $f;
  }
 }
 if(count($items)>0) {
  // Sort in reverse chronological order
  arsort($items);
  echo "<TABLE CLASS=\"MAIL\" WIDTH=100% CELLPADDING=2 CELLSPACING=2>\n";
  echo "<THEAD><TH>Folder</TH></THEAD>\n"; 
  foreach($items as $f) {
   echo "<TR><TD ALIGN=\"CENTER\"><A HREF=\"".$_SERVER['PHP_SELF']."?dir=$f\">".translateQuarantineDate($f)."</A></TD></TR>\n";
  }
  echo "</TABLE>\n";
  closedir($d);  
 } else {
  die("No quarantine directories found\n");
 }
} else {
 // SECURITY: trim off any potential nasties
 $_GET['dir'] = preg_replace('[\.|\.\.|\/]','',$_GET['dir']);
 $items = array();
 // Check file quarantine
 $quarantinepath = $quarantinedir."/".$_GET['dir'];
 if($d = @opendir($quarantinepath)) {
  while(false !== ($f = readdir($d))) {
   if($f != "." && $f != ".." && $f != "spam" && count_files_in_dir($quarantinepath.'/'.$f)>0) {
    $items[] = "'".$f."'";
   }
  }
  closedir($d);
 } else {
  die("Could not open $quarantinepath.\n<BR>");
 }
 // Check spam quarantine
 $spamquarantine = $quarantinepath."/spam/";
 if (@is_dir($spamquarantine)) {
  if($d = @opendir($quarantinepath."/spam/")) {
   while(false !== ($f = readdir($d))) {
    if($f != "." && $f != "..") {
     $items[] = "'".$f."'";
    }
   }
   closedir($d);
  } else {
   echo "Could not open $spamquarantine.\n<BR>";
  }
 }
 // Check non-spam quarantine
 $nonspamquarantine = $quarantinepath."/nonspam/";
 if (@is_dir($nonspamquarantine)) {
  if($d = @opendir($quarantinepath."/nonspam/")) {
   while(false !== ($f = readdir($d))) {
    if($f != "." && $f != "..") {
     $items[] = "'".$f."'";
    }
   }
   closedir($d);
  } else {
   echo "Could not open $nonspamquarantine.\n<BR>";
  }
 }
 // Build list of message id's to be used in SQL statement
 if(count($items) > 0) {
  $msg_ids = join($items, ",");
  $date = mysql_escape_string(translateQuarantineDate($_GET['dir'],'sql'));
  $sql = "
 SELECT
  id AS id2,
  DATE_FORMAT(timestamp, '%d/%m/%y %H:%i:%s') AS datetime,
  from_address,
  to_address,
  subject,
  size,
  sascore,
  isspam,
  ishighspam,
  spamwhitelisted,
  spamblacklisted,
  virusinfected,
  nameinfected,
  otherinfected,
  report,
  '' as status
 FROM
  maillog
 WHERE
  ".$GLOBALS['global_filter']."
 AND
  date = '$date'
 AND
  id IN ($msg_ids)
 ORDER BY
  date DESC, time DESC
 ";
  db_colorised_table($sql,'Folder: '.translateQuarantineDate($_GET['dir']),true,true);
 } else {
  echo "No quarantined messages found\n";
 }
}

html_end();
?>
