<?
/*
 MailWatch for MailScanner
 Copyright (C) 2003  Steve Freegard (smf@f2s.com)

 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

require("./functions.php");
require("./filter.inc");
session_start();
authenticate();

// Continue session
if(isset($_SESSION["filter"])) { $filter = $_SESSION["filter"]; }

report_start("Top Sender Domains by Volume");

$sql = "
 SELECT 
  SUBSTRING_INDEX(from_address, '@', -1) AS from_domain,
  COUNT(*) as count,
  SUM(size) as size
 FROM 
  maillog
 WHERE
  from_address <> \"\"		-- Exclude delivery receipts
 AND
  from_address IS NOT NULL	-- Exclude delivery receipts
".$filter->CreateSQL()." 
 GROUP BY
  from_domain
 ORDER BY
  size DESC
 LIMIT 10
";

# JPGraph
include("./jpgraph/src/jpgraph.php");
include("./jpgraph/src/jpgraph_pie.php");
include("./jpgraph/src/jpgraph_pie3d.php");

$result = dbquery($sql);
if(!mysql_num_rows($result) > 0) {
 die("Error: no rows retrieved from database\n");
}

while($row=mysql_fetch_object($result)) {
 $data[] = $row->count;
 $data_names[] = $row->from_domain;
 $data_size[] = round(($row->size));
}

$graph = new PieGraph(750,400,"top_sender_domains_by_volume.png",0,false);
$graph->SetShadow();
$graph->img->SetAntiAliasing();
$graph->title->Set("Top 10 Sender Domains by Volume");

$p1 = new PiePlot3d($data);
$p1->SetTheme('sand');
$p1->SetLegends($data_names);
$p1->SetCenter(0.3);

$graph->Add($p1);
$graph->Stroke();
?>
<TABLE BORDER=0 CELLPADDING=10 CELLSPACING=0 HEIGHT=100% WIDTH=100%
<TR>
 <TD ALIGN="CENTER"><IMG SRC="images/mailscannerlogo.gif"></TD>
</TR>
<TR>
 <TD ALIGN="CENTER"><IMG SRC="images/cache/top_sender_domains_by_volume.png?<?=time()?>"></TD>
</TR>
<TR>
 <TD ALIGN="CENTER">
  <TABLE WIDTH=500>
   <THEAD BGCOLOR="#F7CE4A">
    <TH>Domain</TH>
    <TH>Count</TH>
    <TH>Size</TH>
   </THEAD>
<?
for($i=0; $i<count($data); $i++) {
 echo "<TR BGCOLOR=\"#EBEBEB\">
 <TD>$data_names[$i]</TD>
 <TD ALIGN=\"RIGHT\">".number_format($data[$i])."</TD>
 <TD ALIGN=\"RIGHT\">".format_mail_size($data_size[$i])."</TD>
</TR>\n";
}
?>
  </TABLE>
 </TD>
</TR>
</TABLE>
<?
html_end();
?>
