<?
require 'functions.php';
require_once 'Mail/mimeDecode.php';
ini_set("memory_limit","128M");

html_start("Message Viewer");

if (!function_exists("file_get_contents")) {
  function file_get_contents($filename, $use_include_path = 0) {
   $file = @fopen($filename, "rb", $use_include_path);
   if ($file) {
     while (!feof($file)) $data .= fread($file, 1024);
     fclose($file);
   }
   return $data;
  }
}

if(!isset($_GET['filename'])) {
 die("No input filename");
} else {
 // SECURITY - strip off any potential nasties
 $_GET['filename'] = preg_replace('[\.\/|\.\.\/]','',$_GET['filename']);
 $filename = get_conf_var('QuarantineDir')."/".$_GET['filename'];
 if(!@file_exists($filename)) {
  die("Error: file not found\n");
 }
}

$file = file_get_contents($filename);

$params['include_bodies'] = false;
$params['decode_bodies'] = true;
$params['decode_headers'] = true;
$params['input'] = $file;

$structure = Mail_mimeDecode::decode($params);
$mime_struct = Mail_mimeDecode::getMimeNumbers($structure);

// echo "<pre>"; print_r($structure); echo "</pre>\n";

echo "<table border=0 class=\"maildetail\" width=100%>\n";
echo " <thead>\n";
echo "  <th colspan=2>Message Viewer: ".$_GET['filename']."</th>\n";
echo " </thead>\n";


function lazy($title, $val) {
 echo " <tr>\n";
 echo "  <td class=\"heading\" align=\"right\" width=10%>$title</td>\n";
 echo "  <td class=\"detail\" width=80%>$val</td>\n";
 echo " </tr>\n";
}

// Display the headers
switch(true) {
 case isset($structure->headers['date']):
  lazy("Date:",$structure->headers['date']);
 case isset($structure->headers['from']):
  lazy("From:",str_replace('"','',$structure->headers['from']));
 case isset($structure->headers['to']):
  lazy("To:",str_replace('"','',$structure->headers['to']));
 case isset($structure->headers['subject']):
  lazy("Subject:",$structure->headers['subject']);
}

foreach($mime_struct as $key=>$part) {
 $type = $part->ctype_primary.'/'.$part->ctype_secondary;
 echo " <tr>\n";
 echo "  <td colspan=2 class=\"heading\">MIME Type: $type</td>\n";

 switch($type) {
  case "text/plain":
  case "text/html":
   echo " <tr>\n";
   echo "  <td colspan=2>\n";
   echo "   <iframe frameborder=0 width=\"100%\" height=300 src=\"viewpart.php?filename=".$_GET['filename']."&part=".$part->mime_id."\"></iframe>\n";
   echo "  </td>\n";
   echo " </tr>\n";
   break;
  case "multipart/alternative":
   break;
  default:
   echo " <tr>\n";
   echo "  <td colspan=2 class=\"detail\">".$part->d_parameters['filename']." <a href=\"viewpart.php?filename=".$_GET['filename']."&part=".$part->mime_id."\">Download</a></td>";
   echo " </tr>\n";
   break;
 }
}


echo "</table>\n";
html_end();
?>
