<?
require 'functions.php';
require_once 'Mail/mimeDecode.php';
ini_set("memory_limit","128M");

if (!function_exists("file_get_contents")) {
  function file_get_contents($filename, $use_include_path = 0) {
   $file = @fopen($filename, "rb", $use_include_path);
   if ($file) {
     while (!feof($file)) $data .= fread($file, 1024);
     fclose($file);
   }
   return $data;
  }
}

if(!isset($_GET['filename'])) {
 die("No input filename");
} else {
 // SECURITY - strip off any potential nasties
 $_GET['filename'] = preg_replace('[\.\/|\.\.\/]','',$_GET['filename']);
 $filename = get_conf_var('QuarantineDir')."/".$_GET['filename'];
 if(!@file_exists($filename)) {
  die("Error: file not found\n");
 }
}


$file = file_get_contents($filename);

$params['include_bodies'] = true;
$params['decode_bodies'] = true;
$params['decode_headers'] = true;
$params['input'] = $file;

$structure = Mail_mimeDecode::decode($params);
$mime_struct = Mail_mimeDecode::getMimeNumbers($structure);

// Make sure that part being requested actually exists
if(isset($_GET['part'])) {
 if(!isset($mime_struct[$_GET['part']])) {
  die("Part ".$_GET['part']." not found\n");
 }
}

function decode_structure($structure) {
 $type = $structure->ctype_primary."/".$structure->ctype_secondary;
 switch($type) {
  case "text/plain":
   echo "<html>\n";
   echo " <head>\n";
   echo " <title>Quarantined E-Mail Viewer</title>\n";
   echo " </head>\n";
   echo " <body>\n";
   echo " <pre>\n";
   echo wordwrap($structure->body);
   echo " </pre>\n";
   echo " </body>\n";
   echo "</html>\n";
   break;
  case "text/html":
   if(STRIP_HTML) {
    echo strip_tags($structure->body, ALLOWED_TAGS);
   } else {
    echo $structure->body;
   }
   break;
  case "multipart/alternative":
   break;
  default:
   header("Content-type: ".$structure->headers['content-type']);
   header("Content-Disposition: ".$structure->headers['content-disposition']);
   echo $structure->body;
   break;
 }
}

decode_structure($mime_struct[$_GET['part']]);

?>
